﻿' copyright (C) 2016 Sohta.

Imports System
Imports System.IO
Imports System.IO.Ports
Imports System.Text
Imports System.Management

Public Class formMain
    Dim appPath As String
    Dim currentSSID As String
    Dim currentIndex As Long
    Dim apEcn(255) As String
    Dim apSSID(255) As String

    Private Structure DispTable
        Public name As String
        Public mode As Long
        Public url As String
    End Structure

    Private Disp0Clock() As DispTable
    Private Disp1Eorzea() As DispTable
    Private Disp2Sensor() As DispTable
    Private Disp3Weather() As DispTable
    Private DispNull(0) As DispTable

    Private Structure ModeToDispIndex
        Public mode As Long
        Public disp1 As Long
        Public disp2 As Long
    End Structure
    Private ModeToDispIndexes() As ModeToDispIndex

    Private DispItems() As DispTable = DispNull
    Private DispItem As DispTable

    Private httpMode As Long

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        appPath = IO.Path.GetDirectoryName(Reflection.Assembly.GetExecutingAssembly().Location)

        ReDim Disp0Clock(5)
        With Disp0Clock(0) : .name = "時 : 分" : .mode = 0 : End With
        With Disp0Clock(1) : .name = "月.日" : .mode = 1 : End With
        With Disp0Clock(2) : .name = "時:分⇔月.日" : .mode = 2 : End With
        With Disp0Clock(3) : .name = "年" : .mode = 3 : End With
        With Disp0Clock(4) : .name = "曜日" : .mode = 4 : End With
        With Disp0Clock(5) : .name = "秒" : .mode = 5 : End With

        ReDim Disp1Eorzea(3)
        With Disp1Eorzea(0) : .name = "時 : 分" : .mode = 10 : End With
        With Disp1Eorzea(1) : .name = "月.日" : .mode = 11 : End With
        With Disp1Eorzea(2) : .name = "時:分⇔月.日" : .mode = 12 : End With
        With Disp1Eorzea(3) : .name = "年" : .mode = 13 : End With

        ReDim Disp2Sensor(2)
        With Disp2Sensor(0) : .name = "電池電圧" : .mode = &H10 : End With
        With Disp2Sensor(1) : .name = "TP1 ON/OFF" : .mode = &H12 : End With
        With Disp2Sensor(2) : .name = "TP1 電圧" : .mode = &H11 : End With

        ReDim Disp3Weather(0)
        With Disp3Weather(0) : .name = "東京" : .mode = &H20 : .url = "weathertokyo.txt" : End With

        With DispNull(0) : .name = "" : .mode = &H20 : End With

        ReDim ModeToDispIndexes(Disp0Clock.Count + Disp1Eorzea.Count + Disp2Sensor.Count - 1)
        Dim i As Long
        Dim j As Long
        For Each item In Disp0Clock
            With ModeToDispIndexes(i)
                .mode = item.mode
                .disp1 = 0
                .disp2 = j
            End With
            i += 1
            j += 1
        Next
        j = 0
        For Each item In Disp1Eorzea
            With ModeToDispIndexes(i)
                .mode = item.mode
                .disp1 = 1
                .disp2 = j
            End With
            i += 1
            j += 1
        Next
        j = 0
        For Each item In Disp2Sensor
            With ModeToDispIndexes(i)
                .mode = item.mode
                .disp1 = 2
                .disp2 = j
            End With
            i += 1
            j += 1
        Next

        comboDisp2.Enabled = False : comboDisp1.SelectedIndex = 0 : comboDisp2.Enabled = True
        comboPost2.Enabled = False : comboPost2.SelectedIndex = 0 : comboPost2.Enabled = True
        comboPost1.Enabled = False : comboPost1.SelectedIndex = 0 : comboPost1.Enabled = True
        scanComPort()
    End Sub

    Public Sub scanComPort()
        comboComport.Items.Clear()
        Try
            Dim searcher As New ManagementObjectSearcher
            searcher.Query.QueryString = "select * from Win32_PnPEntity " &
                                    "where Name like '%(COM%' and ConfigManagerErrorCode = 0"

            Dim obj As ManagementObject
            For Each obj In searcher.Get()
                'HardwareID - USB\VID_04D8&PID_000A&REV_0100, USB\VID_04D8&PID_000A
                For Each HardwareID In obj.Item("HardwareID")
                    If (HardwareID = "USB\VID_04D8&PID_000A") Or (HardwareID = "USB\VID_22EA&PID_004C") Then
                        'Name - USB Serial Port (COM9)
                        Dim name As String = obj.Item("Name")
                        name = Mid(name, 1 + name.IndexOf("("c) + 1)
                        name = name.Replace(")"c, "")
                        comboComport.Items.Add(name)
                        Exit For
                    End If
                Next
            Next
            If comboComport.Items.Count >= 1 Then
                comboComport.SelectedIndex = 0
            End If
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Private Sub comboComport_Click(sender As Object, e As EventArgs) Handles comboComport.Click
        'If comboComport.Items.Count = 0 Then
        scanComPort()
        'End If
    End Sub

    Private Sub comboComport_SelectedIndexChanged(sender As Object, e As EventArgs) Handles comboComport.SelectedIndexChanged
        SerialPort1.PortName = comboComport.SelectedItem.ToString
    End Sub

    'ATWPS         - connect to AP with WPS
    'ATCON=SSID PASSWORD - connect to AP with password
    'ATCON         - display registered AP
    'AT+CWLAP      - scan AP
    'AT+GMR        - SW version
    'AT+RST        - reboot (reconnect to AP And NTP server)
    'AT+RESTORE    - clear AP settings

    Private Sub buttonScan_Click(sender As Object, e As EventArgs) Handles buttonScan.Click
        buttonScan.Enabled = False
        buttonWPS.Enabled = False
        buttonConnect.Enabled = False

        Try
            SerialPort1OpenConsole()

            '+CWLAP:(3,"0022CF375B5C",-42,"74:03:bd:b2:57:d0",11,-19,0)
            Dim i As Long
            Dim txtLine As String

            readWlanVer()

            SerialPort1.WriteLine("ATCON")
            For i = 0 To 255
                txtLine = SerialPort1.ReadLine()
                If i = 1 Then currentSSID = txtLine.Replace(vbCr, "")
                If txtLine = ("OK" & vbCr) Or Mid(txtLine, 1, 5) = "ERROR" Then Exit For
            Next

            SerialPort1.WriteLine("AT+CIPSTAMAC?")
            Do While 1
                txtLine = SerialPort1.ReadLine()
                If Mid(txtLine, 1, 11) = "+CIPSTAMAC:" Then
                    labelMAC.Text = Mid(txtLine, 12).Replace(""""c, "")
                End If
                If txtLine = ("OK" & vbCr) Or Mid(txtLine, 1, 5) = "ERROR" Then Exit Do
            Loop

            SerialPort1.WriteLine("AT+CWLAPOPT=1,127")
            Do While 1
                txtLine = SerialPort1.ReadLine()
                If txtLine = ("OK" & vbCr) Or Mid(txtLine, 1, 5) = "ERROR" Then Exit Do
            Loop

            listAP.Items.Clear()
            Application.DoEvents()
            currentIndex = -1

            SerialPort1.WriteLine("AT+CWLAP")
            i = 0
            Do While 1
                txtLine = SerialPort1.ReadLine()
                If txtLine = ("OK" & vbCr) Or Mid(txtLine, 1, 5) = "ERROR" Then Exit Do
                If Mid(txtLine, 1, 8) = "+CWLAP:(" Then
                    txtLine = Mid(txtLine, 9)
                    Dim apParamArray() As String = txtLine.Split(","c)
                    apEcn(i) = apParamArray(0)
                    txtLine = apParamArray(1)
                    If txtLine.First = """"c Then txtLine = Mid(txtLine, 2)
                    If txtLine.Last = """"c Then txtLine = Mid(txtLine, 1, txtLine.Length - 1)
                    apSSID(i) = txtLine

                    If txtLine = currentSSID Then
                        currentIndex = i
                        listAP.Items.Add(txtLine & " (設定済)")
                    Else
                        listAP.Items.Add(txtLine)
                    End If
                    i += 1
                End If
            Loop
            If currentIndex >= 0 Then
                listAP.SelectedIndex = currentIndex
                buttonConnect.Enabled = True
                buttonConnect.Select()
            End If

        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
        SerialPort1Close()
        buttonScan.Enabled = True
        buttonWPS.Enabled = True
    End Sub

    Private Sub buttonConnect_Click(sender As Object, e As EventArgs) Handles buttonConnect.Click
        buttonScan.Enabled = False
        buttonWPS.Enabled = False
        buttonConnect.Enabled = False
        Dim index As Long = -1

        Try
            'ATCON=SSID PASSWORD - connect to AP with password
            'OK
            'S2:WIFI CONNECTING
            'S3:WIFI CONNECTED
            'S4:WIFI GOT IP
            'S5:05/18 Wed 20:08:29

            Dim txtLine As String
            index = listAP.SelectedIndex

            If currentIndex >= 0 Then
                listAP.Items(currentIndex) = apSSID(currentIndex)
                Application.DoEvents()
                currentIndex = index
            End If

            If apEcn(index) = "0" Then
                txtLine = ""
            Else
                Dim f As New formPassword
                f.ShowDialog()
                txtLine = f.txtPassword
                f.Dispose()
                If txtLine = "" Then Exit Try
            End If

            listAP.Items(index) = apSSID(index) & " (準備中..)"

            SerialPort1OpenConsole()
            readWlanVer()

            If apSSID(index).IndexOf(" "c) > 0 Then
                SerialPort1.WriteLine("ATCON=""" & apSSID(index) & """ " & txtLine)
            Else
                SerialPort1.WriteLine("ATCON=" & apSSID(index) & " " & txtLine)
            End If
            Do
                txtLine = SerialPort1.ReadLine()
            Loop Until txtLine = ("OK" & vbCr) Or Mid(txtLine, 1, 5) = "ERROR"

            SerialPort1.WriteLine("AT+RST")

            Dim ErrorMessage As String
            Dim startTime As Long
            startTime = Environment.TickCount
            ErrorMessage = "なんか変なことが起きました"
            SerialPort1.ReadTimeout = 1000
            Do While 1
                txtLine = SerialPort1ReadLineTimeout()
                Select Case Mid(txtLine, 1, 3)
                    Case "S2:"
                        startTime = Environment.TickCount
                        listAP.Items(index) = apSSID(index) & " (接続中..)"
                        ErrorMessage = "アクセスポイント " & apSSID(index) & " に接続できませんでした(Err.2)"
                    Case "S3:"
                        startTime = Environment.TickCount
                        listAP.Items(index) = apSSID(index) & " (IP取得中..)"
                        ErrorMessage = "IPアドレスを取得できませんでした(Err.3)"
                    Case "S4:"
                        startTime = Environment.TickCount
                        listAP.Items(index) = apSSID(index) & " (NTP接続中..)"
                        ErrorMessage = "NTPサーバーにアクセスできませんでした(Err.4)"
                    Case "S5:"
                        listAP.Items(index) = apSSID(index) & " (設定済)"
                        ErrorMessage = "接続に成功しました！"
                        Exit Do
                End Select
                If Environment.TickCount - startTime >= TIMEOUT_CONNECT Then
                    listAP.Items(index) = apSSID(index) & " (失敗)"
                    Exit Do
                End If
            Loop
            MsgBox(ErrorMessage)
        Catch ex As Exception
            If index >= 0 Then listAP.Items(index) = apSSID(index)
            MsgBox(ex.Message)
        End Try

        SerialPort1Close()
        buttonScan.Enabled = True
        buttonWPS.Enabled = True
        buttonConnect.Enabled = True
    End Sub

    Private Sub listAP_SelectedIndexChanged(sender As Object, e As EventArgs) Handles listAP.SelectedIndexChanged
        buttonConnect.Enabled = True
    End Sub

    Private Sub listAP_DoubleClick(sender As Object, e As EventArgs) Handles listAP.DoubleClick
        buttonConnect_Click(sender, e)
    End Sub

    Private Sub buttonWPS_Click(sender As Object, e As EventArgs) Handles buttonWPS.Click
        buttonScan.Enabled = False
        buttonWPS.Enabled = False
        buttonConnect.Enabled = False
        Dim fWPS As New formWPS

        Try
            SerialPort1OpenConsole()

            readWlanVer()

            Dim txtline As String

            If (currentIndex >= 0) And (listAP.Items.Count > currentIndex) Then
                listAP.Items(currentIndex) = apSSID(currentIndex)
                Application.DoEvents()
                currentIndex = -1
            End If

            fWPS.ShowDialog()

            If fWPS.result = 1 Then
                SerialPort1.ReadTimeout = TIMEOUT_COMMAND
                SerialPort1.ReadExisting()
                SerialPort1.WriteLine("ATCON")
                Dim i As Long
                For i = 0 To 255
                    txtline = SerialPort1.ReadLine()
                    If txtline = ("OK" & vbCr) Or Mid(txtline, 1, 5) = "ERROR" Then Exit For
                    If i = 1 Then currentSSID = txtline.Replace(vbCr, "")
                Next

                currentIndex = 0
                apSSID(0) = currentSSID
                listAP.Items.Clear()
                listAP.Items.Add(apSSID(0) & " (設定済)")
            End If
        Catch ex As Exception
            fWPS.Close()
            MsgBox(ex.Message)
        End Try
        fWPS.Dispose()
        SerialPort1Close()
        buttonScan.Enabled = True
        buttonWPS.Enabled = True
    End Sub

    Private Function readWlanVer()
        'AT+GMR
        'AT Version: 0.60.0.0(Jan 29 2016 15:10:17)
        'SDK Version: 1.5.2(80914727)
        'Wlan Clock(W0.911)
        'OK
        Dim txtLine As String
        Dim i As Long

        SerialPort1.WriteLine("AT+GMR")
        Do While 1
            Try
                SerialPort1.ReadTimeout = 1000
                txtLine = SerialPort1.ReadLine()
                If txtLine = ("OK" & vbCr) Or Mid(txtLine, 1, 5) = "ERROR" Then Exit Do
                If Mid(txtLine, 1, 12) = "Wlan Clock (" Then
                    labelWlanVer.Text = Mid(txtLine, 13).Replace(vbCr, "").Replace(")", "")
                End If
                If Mid(txtLine, 1, 5) = "ERROR" Then SerialPort1.WriteLine("AT+GMR")
            Catch ex As TimeoutException
                i += 1
                If i > 10 Then Throw New Exception("cannot read FW version")
                SerialPort1.WriteLine("AT+GMR")
            End Try
        Loop
        SerialPort1.ReadTimeout = 5000
        readWlanVer = 1
    End Function

    Private Function getParam(top As String) As String()
        Dim output As New ArrayList
        Dim pos As Long
        Dim i As Long

        Do While 1
            Do While Mid(top, 1, 1) = " "c
                top = Mid(top, 2)
            Loop

            If top = "" Then GoTo _Exit

            If Mid(top, 1, 1) = """"c Then
                top = Mid(top, 2)
                pos = top.IndexOf(""""c)
                If pos < 0 Then GoTo _exit
            Else
                pos = top.IndexOf(" "c)
                If pos < 0 Then GoTo _exit
            End If
            output.Add(Mid(top, 1, pos))
            top = Mid(top, 2 + pos)
        Loop

_Exit:
        If top <> "" Then output.Add(top)

        Dim tmp() As String : ReDim tmp(output.Count - 1)
        For i = 0 To output.Count - 1
            tmp(i) = output(i)
        Next
        getParam = tmp
    End Function

    Private Sub buttonReadVer_Click(sender As Object, e As EventArgs) Handles buttonReadVer.Click
        buttonReadVer.Enabled = False

        Try
            labelPicVer.Text = "xxxx"
            labelWlanVer.Text = "xxxx"

            SerialPort1OpenConsole()
            readWlanVer()

            Dim txtLine As String = ""
            Dim i As Long

            SerialPort1.WriteLine("U")
            For i = 0 To 255
                txtLine = SerialPort1.ReadLine()
                txtLine = txtLine.Replace(vbCr, "")
                If Mid(txtLine, 1, 4) = "PIC:" Then
                    labelPicVer.Text = Mid(txtLine, 1 + 4)
                End If
                If Mid(txtLine, 1, 5) = "ERROR" Then Exit For
            Next

            SerialPort1.WriteLine("AT+CIPSTAMAC?")
            Do While 1
                txtLine = SerialPort1.ReadLine()
                If Mid(txtLine, 1, 11) = "+CIPSTAMAC:" Then
                    labelMAC2.Text = Mid(txtLine, 12).Replace(""""c, "")
                End If
                If txtLine = ("OK" & vbCr) Or Mid(txtLine, 1, 5) = "ERROR" Then Exit Do
            Loop

            Dim modes() As String
            SerialPort1.WriteLine("ATMODE")
            Do While 1
                txtLine = SerialPort1.ReadLine()
                txtLine = txtLine.Replace(vbCr, "")
                If Mid(txtLine, 1, 3) = "S8:" Then
                    modes = getParam(Mid(txtLine, 4))
                End If
                If txtLine = "OK" Or Mid(txtLine, 1, 5) = "ERROR" Then Exit Do
            Loop

            Dim https() As String
            SerialPort1.WriteLine("ATHTTP")
            Do While 1
                txtLine = SerialPort1.ReadLine()
                txtLine = txtLine.Replace(vbCr, "")
                If txtLine = "ATHTTP" Then Continue Do
                If Mid(txtLine, 3, 1) = ":" Then Continue Do
                Exit Do
            Loop
            https = getParam(txtLine)
            Do
                txtLine = SerialPort1.ReadLine()
            Loop Until txtLine = ("OK" & vbCr) Or Mid(txtLine, 1, 5) = "ERROR"

            Dim dispMode As Long
            Dim postMode As Long
            If modes.Count = 0 Then Throw New Exception("ATMODE error")
            dispMode = Val(modes(0))
            If modes.Count >= 2 Then postMode = Val(modes(1))

            comboDisp2.Enabled = False
            comboPost1.Enabled = False

            If dispMode = &H20 Then
                comboDisp1.SelectedIndex = 4    ' その他
                comboDisp2.SelectedIndex = 0
            Else
                For Each table In ModeToDispIndexes
                    If dispMode = table.mode Then
                        comboDisp1.SelectedIndex = table.disp1
                        comboDisp2.SelectedIndex = table.disp2
                        Exit For
                    End If
                Next
            End If

            If postMode >= 0 And postMode <= 3 Then
                comboPost1.SelectedIndex = postMode
            End If

            comboDisp2.Enabled = True
            comboPost1.Enabled = True

            If https.Count < 1 Then Exit Try
            i = Val("&H" & https(0))

            comboPost2.Enabled = False
            If i >= 2 Then
                comboPost2.SelectedIndex = i - 2
            Else
                httpMode = i
                comboPost2_SelectedIndexChanged(sender, e)
            End If
            comboPost2.Enabled = True

            If https.Count >= 2 Then textParam1.Text = https(1)
            If https.Count >= 3 Then textParam2.Text = https(2)
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
        SerialPort1Close()

        Try
            Dim wc As Net.WebClient = New Net.WebClient()
            wc.DownloadFile("http://sohta02.web.fc2.com/release/bitClock.PicFW.latest.hex", appPath & "\latest_pic.hex")
            wc.DownloadFile("http://sohta02.web.fc2.com/release/bitClock.WlanFW.latest.txt", appPath & "\latest_wlan.txt")

            Dim binSize As Long
            Dim binBuf(&H4000 - 1) As Byte
            readPicFW(appPath & "\latest_pic.hex", binBuf, binSize)

            Dim picVer As String = "0000" & Hex(binBuf(&H1816) + binBuf(&H1817) * 256)
            labelPicLatest.Text = Mid(picVer, 1 + picVer.Length - 4)

            Dim fs As New StreamReader(appPath & "\latest_wlan.txt")
            Dim lineText As String
            lineText = fs.ReadLine()
            fs.Close()
            labelWlanLatest.Text = lineText
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

        buttonReadVer.Enabled = True
    End Sub

    Private Sub comboDisp1_SelectedIndexChanged(sender As Object, e As EventArgs) Handles comboDisp1.SelectedIndexChanged
        DispItems = DispNull
        Select Case comboDisp1.SelectedIndex
            Case 0
                DispItems = Disp0Clock
            Case 1
                DispItems = Disp1Eorzea
            Case 2
                DispItems = Disp2Sensor
            Case 3
                DispItems = Disp3Weather
        End Select

        comboDisp2.Items.Clear()
        comboDisp2.BeginUpdate()
        For Each item In DispItems
            comboDisp2.Items.Add(item.name)
        Next
        comboDisp2.EndUpdate()
        comboDisp2.SelectedIndex = 0
    End Sub

    Private Sub comboDisp2_SelectedIndexChanged(sender As Object, e As EventArgs) Handles comboDisp2.SelectedIndexChanged
        DispItem = DispItems(comboDisp2.SelectedIndex)

        If comboDisp2.Enabled = False Then Exit Sub
        comboDisp2.Enabled = False
        Dim txtline As String
        Try
            SerialPort1OpenConsole()

            If DispItem.mode = &H20 Then
                comboPost1.Enabled = False : comboPost1.SelectedIndex = 0 : comboPost1.Enabled = True
                comboPost2.Enabled = False : comboPost2_SelectedIndexChanged(sender, e) : comboPost2.Enabled = True
            End If

            SerialPort1.WriteLine("ATMODE=" & DispItem.mode.ToString & " " & comboPost1.SelectedIndex.ToString)
            Do
                txtline = SerialPort1.ReadLine()
            Loop Until txtline = ("OK" & vbCr) Or Mid(txtline, 1, 5) = "ERROR"

            If DispItem.mode = &H20 Then
                If DispItem.url <> "" Then
                    textParam1.Text = "sohta02.web.fc2.com/" & DispItem.url
                    textParam2.Text = ""
                End If

                If textParam2.Text = "" Then
                    SerialPort1.WriteLine("ATHTTP=" & httpMode.ToString & " """ & textParam1.Text & """")
                Else
                    SerialPort1.WriteLine("ATHTTP=" & httpMode.ToString & " """ & textParam1.Text & """ """ & textParam2.Text & """")
                End If
                Do
                    txtline = SerialPort1.ReadLine()
                Loop Until txtline = ("OK" & vbCr) Or Mid(txtline, 1, 5) = "ERROR"

                SerialPort1.WriteLine("AT+RST")
                Do
                    txtline = SerialPort1.ReadLine()
                Loop Until txtline = ("OK" & vbCr) Or Mid(txtline, 1, 5) = "ERROR"
            End If
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
        SerialPort1Close()
        comboDisp2.Enabled = True
    End Sub

    Private Sub comboPost1_SelectedIndexChanged(sender As Object, e As EventArgs) Handles comboPost1.SelectedIndexChanged
        If comboPost1.Enabled = False Then Exit Sub
        comboPost1.Enabled = False

        If comboPost1.SelectedIndex <> 0 And DispItem.mode = &H20 Then
            comboDisp2.Enabled = False : comboDisp1.SelectedIndex = 0 : comboDisp2.Enabled = True
        End If
        comboDisp1_SelectedIndexChanged(sender, e)
        comboPost2_SelectedIndexChanged(sender, e)

        If comboPost1.SelectedIndex <> 0 Then
            Try
                SerialPort1OpenConsole()

                Dim txtline As String
                If textParam2.Text = "" Then
                    SerialPort1.WriteLine("ATHTTP=" & httpMode.ToString & " """ & textParam1.Text & """")
                Else
                    SerialPort1.WriteLine("ATHTTP=" & httpMode.ToString & " """ & textParam1.Text & """ """ & textParam2.Text & """")
                End If
                Do
                    txtline = SerialPort1.ReadLine()
                Loop Until txtline = ("OK" & vbCr) Or Mid(txtline, 1, 5) = "ERROR"

                SerialPort1.WriteLine("AT+RST")
                Do
                    txtline = SerialPort1.ReadLine()
                Loop Until txtline = ("OK" & vbCr) Or Mid(txtline, 1, 5) = "ERROR"
            Catch ex As Exception
                MsgBox(ex.Message)
            End Try
            SerialPort1Close()
        End If

        comboPost1.Enabled = True
    End Sub

    Private Sub comboPost2_SelectedIndexChanged(sender As Object, e As EventArgs) Handles comboPost2.SelectedIndexChanged
        If DispItem.mode = &H20 Then
            labelParam1.Text = "URL"
            labelParam2.Text = ""
            textParam1.Enabled = True
            textParam2.Enabled = True
            If httpMode <> 0 Then
                textParam1.Text = ""
                textParam2.Text = ""
                httpMode = 0
            End If
            Exit Sub
        End If

        If httpMode = comboPost2.SelectedIndex + 2 Then Exit Sub
        httpMode = comboPost2.SelectedIndex + 2

        labelParam1.Text = ""
        labelParam2.Text = ""
        textParam1.Text = ""
        textParam2.Text = ""
        buttonToken.Visible = True
        textParam1.Enabled = True
        textParam2.Enabled = True

        Select Case httpMode
            Case 2          ' sohtamei
                buttonToken.Text = "サイト"
                textParam1.Enabled = False
                textParam2.Enabled = False

            Case 3          ' ThingSpeak
                labelParam1.Text = "API key"
                buttonToken.Text = "サイト"

            Case 4          ' tiwitter
                labelParam1.Text = "トークン"
                labelParam2.Text = "メッセージ"
                buttonToken.Text = "トークン取得"

            Case 5          ' IFTTT
                labelParam1.Text = "key"
                labelParam2.Text = "event"
                buttonToken.Text = "サイト"

            Case 6
                labelParam1.Text = "URL"
                buttonToken.Visible = False

            Case Else
                buttonToken.Visible = False
                textParam1.Enabled = False
                textParam2.Enabled = False
        End Select

        If comboPost2.Enabled = False Then Exit Sub

        If httpMode = 2 Then             ' sohtamei
            buttonHttp_Click(sender, e)
        End If
    End Sub

    Private Sub buttonToken_Click(sender As Object, e As EventArgs) Handles buttonToken.Click
        Dim url As String = ""
        Select Case httpMode
            Case 2
                url = "http://sohta02.yuzu.bz/bitclock_webinfo2.html"
            Case 3
                url = "https://thingspeak.com/channels"
            Case 4
                url = "https://server7.fc2-rentalserver.com/~sohta02/get-access-token.php"
            Case 5
                'url = "https://ifttt.com/"
                url = "https://ifttt.com/services/maker/settings"
        End Select
        If url <> "" Then Diagnostics.Process.Start(url)
    End Sub

    Private Sub buttonPaste1_Click(sender As Object, e As EventArgs) Handles buttonPaste1.Click
        If Clipboard.ContainsText() Then textParam1.Text = Clipboard.GetText()
    End Sub

    Private Sub buttonPaste2_Click(sender As Object, e As EventArgs) Handles buttonPaste2.Click
        If Clipboard.ContainsText() Then textParam2.Text = Clipboard.GetText()
    End Sub

    Private Sub buttonHttp_Click(sender As Object, e As EventArgs) Handles buttonHttp.Click
        If textParam1.Text = "" And httpMode <> 2 Then Exit Sub
        buttonHttp.Enabled = False

        Try
            SerialPort1OpenConsole()

            Dim txtline As String
            If textParam2.Text = "" Then
                SerialPort1.WriteLine("ATHTTP=" & httpMode.ToString & " """ & textParam1.Text & """")
            Else
                SerialPort1.WriteLine("ATHTTP=" & httpMode.ToString & " """ & textParam1.Text & """ """ & textParam2.Text & """")
            End If
            Do
                txtline = SerialPort1.ReadLine()
            Loop Until txtline = ("OK" & vbCr) Or Mid(txtline, 1, 5) = "ERROR"

            SerialPort1.WriteLine("AT+RST")
            Do
                txtline = SerialPort1.ReadLine()
            Loop Until txtline = ("OK" & vbCr) Or Mid(txtline, 1, 5) = "ERROR"
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
        SerialPort1Close()

        buttonHttp.Enabled = True
    End Sub

    Private Function readPicFW(filename As String, ByRef binBuf() As Byte, ByRef binSize As Long)
        Dim fs As New StreamReader(filename)

        Dim i As Long
        For i = 0 To binBuf.Count - 1
            binBuf(i) = &HFF
        Next

        Dim baseAdrs As ULong
        Do While 1
            Dim lineText As String
            Dim lineBuf(4 + 32 + 1 - 1) As Byte
            lineText = fs.ReadLine()
            If lineText = "" Then Exit Do

            ':10 0030 00 F26AFC6A266A0001706B716B06EC00F0D4
            If Mid(lineText, 1, 1) <> ":" Then Throw New Exception("hex file error")
            Dim sum As ULong
            For i = 0 To (lineText.Length - 1) / 2 - 1
                lineBuf(i) = Val("&h" & Mid(lineText, 2 + i * 2, 2))
                sum += lineBuf(i)
            Next

            If lineBuf(0) <> (lineText.Length - 1) / 2 - 5 Then Throw New Exception("hex file error")
            If (sum Mod &H100) <> 0 Then Throw New Exception("hex file error")

            Select Case lineBuf(3)
                Case 0
                    If baseAdrs = 0 Then
                        Dim offset As ULong
                        offset = lineBuf(1) * &H100 + lineBuf(2)
                        If binSize < offset + lineBuf(0) Then binSize = offset + lineBuf(0)
                        If binSize > binBuf.Count Then Throw New Exception("hex file error")

                        For i = 0 To lineBuf(0) - 1
                            binBuf(offset + i) = lineBuf(4 + i)
                        Next
                    End If
                Case 4
                    baseAdrs = lineBuf(4) * &H1000000UL + lineBuf(5) * &H10000UL
            End Select
        Loop
        fs.Close()

        binSize = (binSize + 1023) And (Not 1023)
        If (binSize <= &H1800) Then Throw New Exception("hex file error")
        readPicFW = 1
    End Function

    Private Sub buttonBurnFW_Click(sender As Button, e As EventArgs) Handles buttonBurnFW.Click

        buttonBurnFW.Enabled = False
        buttonBurnWlan.Enabled = False
        buttonBurnPicWlan.Enabled = False
        labelStatus.Text = ""
        progressWlan.Value = 0

        Try
            Dim wc As Net.WebClient = New Net.WebClient()
            wc.DownloadFile("http://sohta02.web.fc2.com/release/bitClock.PicFW.latest.hex", appPath & "\latest_pic.hex")
        Catch ex As Exception
        End Try

        Try
            'AT+GMR
            'AT Version: 0.60.0.0(Jan 29 2016 15:10:17)
            'SDK Version: 1.5.2(80914727)
            'Wlan Clock(Apr 11 2016 09: 14:29)
            'OK
            SerialPort1Open()

            OpenFileDialog1.InitialDirectory = appPath
            OpenFileDialog1.FileName = "latest_pic.hex" 'bin"
            OpenFileDialog1.Filter = "PICソフト|*.hex"
            If sender.Name <> "buttonBurnPicWlan" Then
                If OpenFileDialog1.ShowDialog() <> DialogResult.OK Then GoTo Exit_
            End If

            Dim i As Long
            Dim binSize As Long
            Dim binBuf(&H4000 - 1) As Byte
            readPicFW(OpenFileDialog1.FileName, binBuf, binSize)

            Dim portName As String = SerialPort1.PortName
            Dim startTime As Long

            SerialPort1.WriteLine("")
            SerialPort1.WriteLine("U1")
            Threading.Thread.Sleep(100)
            SerialPort1Close()
            Const WaitRebooting = 10
            For i = 0 To WaitRebooting - 1
                Threading.Thread.Sleep(1000)
                progressWlan.Value = (i + 1) * 80 / WaitRebooting
            Next

            startTime = Environment.TickCount
            Do While 1
                Dim name As String
                For Each name In SerialPort.GetPortNames
                    If name = portName Then Exit Do
                Next
                If Environment.TickCount - startTime >= 10000 Then Throw New Exception("失敗")
                Threading.Thread.Sleep(1000)
            Loop

            SerialPort1Open()
            Dim rcvBuf(65535) As Byte
            Dim sendBuf((5 + 1024) - 1) As Byte
            Dim readNum As Long
            SerialPort1.ReadTimeout = 5000

            ' R:"C"
            startTime = Environment.TickCount
            Do While 1
                readNum = SerialPort1.Read(rcvBuf, 0, rcvBuf.Count)
                If (readNum > 0) And (rcvBuf(0) = Asc("C"c)) Then Exit Do
                If Environment.TickCount - startTime >= TIMEOUT_BURN Then
                    MsgBox("失敗")
                    Exit Try
                End If
            Loop

            'W:01 00 FF (SOH,Block0)
            '	"abc.txt" 00
            '	"519 12715566427 100644"
            sendBuf(0) = &H1
            sendBuf(1) = &H0
            sendBuf(2) = &HFF
            sendBuf(3) = Asc("X"c)  ' filename(dummy)
            sendBuf(4) = 0
            If binSize >= 10000 Then
                sendBuf(5) = Asc("0"c) + (binSize / 10000) Mod 10
                sendBuf(6) = Asc("0"c) + (binSize / 1000) Mod 10
                sendBuf(7) = Asc("0"c) + (binSize / 100) Mod 10
                sendBuf(8) = Asc("0"c) + (binSize / 100) Mod 10
                sendBuf(9) = Asc("0"c) + (binSize / 1) Mod 10
            Else
                sendBuf(5) = Asc("0"c) + (binSize / 1000) Mod 10
                sendBuf(6) = Asc("0"c) + (binSize / 100) Mod 10
                sendBuf(7) = Asc("0"c) + (binSize / 100) Mod 10
                sendBuf(8) = Asc("0"c) + (binSize / 1) Mod 10
                sendBuf(9) = 0
            End If
            SerialPort1.Write(sendBuf, 0, 5 + 128)

            'R:06(ACK)
            'R:"C"
            readNum = SerialPort1.Read(rcvBuf, 0, 1)
            If (readNum = 0) Or (rcvBuf(0) <> &H6) Then
                MsgBox("失敗")
                Exit Try
            End If
            readNum = SerialPort1.Read(rcvBuf, 0, rcvBuf.Count)
            If (readNum = 0) Or (rcvBuf(0) <> Asc("C"c)) Then
                MsgBox("失敗")
                Exit Try
            End If
            For i = 0 To (binSize / 1024) - 1
                'W:02 01 FE (STX,Block1)
                sendBuf(0) = &H2
                sendBuf(1) = i + 1
                sendBuf(2) = 255 - (i + 1)
                Dim j As Long
                For j = 0 To 1024 - 1
                    sendBuf(3 + j) = binBuf(i * 1024 + j)
                Next
                SerialPort1.Write(sendBuf, 0, 5 + 1024)

                'R:06(ACK)
                readNum = SerialPort1.Read(rcvBuf, 0, rcvBuf.Count)
                If (readNum = 0) Or (rcvBuf(0) <> &H6) Then
                    MsgBox("失敗")
                    Exit Try
                End If
            Next

            'W:04(EOT)
            'R:15(NAK)
            'W:04(EOT)
            'R:06(ACK)
            sendBuf(0) = &H4
            SerialPort1.Write(sendBuf, 0, 1)
            readNum = SerialPort1.Read(rcvBuf, 0, rcvBuf.Count)
            sendBuf(0) = &H4
            SerialPort1.Write(sendBuf, 0, 1)
            readNum = SerialPort1.Read(rcvBuf, 0, rcvBuf.Count)
            If (readNum = 0) Or (rcvBuf(0) <> &H6) Then
                MsgBox("失敗")
                Exit Try
            End If

            'R:"C"
            'W:01 00 FF (SOH,Block0)
            '	00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 
            '	00 00
            'R:06(ACK)

            'W:"R"
            sendBuf(0) = Asc("R"c)
            SerialPort1.Write(sendBuf, 0, 1)
            SerialPort1Close()
            progressWlan.Value = 100

            labelStatus.Text = "成功しました"
        Catch ex As Exception
            MsgBox(ex.Message)
            labelStatus.Text = "失敗しました"
        End Try
Exit_:
        SerialPort1Close()
        buttonBurnFW.Enabled = True
        buttonBurnWlan.Enabled = True
        buttonBurnPicWlan.Enabled = True
    End Sub

    Private Sub setUlong(buf() As Byte, offset As Long, data As ULong)
        buf(offset + 0) = (data) Mod &H100
        buf(offset + 1) = (data \ &H100UL) Mod &H100
        buf(offset + 2) = (data \ &H10000UL) Mod &H100
        buf(offset + 3) = (data \ &H1000000UL) Mod &H100
    End Sub

    Private Function Send8266Cmd(cmd As ULong, param As ULong, data() As Byte, ByRef rcvParam As ULong) As Long

        Send8266Cmd = 0

        Try
            Dim dataSize As Long
            dataSize = data.Count

            ' C0 00 08 24 00	00000000	20120707	55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 C0

            Dim sendBuf(8 + dataSize - 1) As Byte
            sendBuf(0) = 0
            sendBuf(1) = cmd
            sendBuf(2) = dataSize Mod &H100
            sendBuf(3) = dataSize \ &H100
            setUlong(sendBuf, 4, param)

            Dim i As Long
            Dim j As Long
            For i = 0 To dataSize - 1
                sendBuf(8 + i) = data(i)
            Next

            Dim sendBuf2(sendBuf.Count * 2 - 1) As Byte
            j = 0
            sendBuf2(j) = &HC0 : j += 1
            For i = 0 To sendBuf.Count - 1
                Select Case sendBuf(i)
                    Case &HC0
                        sendBuf2(j) = &HDB : j += 1
                        sendBuf2(j) = &HDC : j += 1
                    Case &HDB
                        sendBuf2(j) = &HDB : j += 1
                        sendBuf2(j) = &HDD : j += 1
                    Case Else
                        sendBuf2(j) = sendBuf(i) : j += 1
                End Select
            Next
            sendBuf2(j) = &HC0 : j += 1

            SerialPort1.Write(sendBuf2, 0, j)

            ' C0 01 08 02 00	20120707	0000 C0
            Dim rcvBuf((8 + 1024) * 2 - 1) As Byte
            Dim rcvData As Byte
            Do While 1
                rcvData = SerialPort1.ReadByte()
                If rcvData = &HC0 Then Exit Do
            Loop

            i = 0
            Do While 1
                rcvData = SerialPort1.ReadByte()
                If rcvData = &HC0 Then
                    If i > 0 Then Exit Do
                Else
                    If rcvData = &HDB Then
                        rcvData = SerialPort1.ReadByte()
                        Select Case rcvData
                            Case &HDC
                                rcvData = &HC0
                            Case &HDD
                                rcvData = &HDB
                            Case Else
                                Throw New Exception("Invalid SLIP escape")
                        End Select
                    End If
                    rcvBuf(i) = rcvData
                    i += 1
                    If i >= rcvBuf.Count Then Throw New Exception("overflow")
                End If
            Loop

            If (rcvBuf(0) <> 1) Or _
                (rcvBuf(1) <> cmd) Or _
                (rcvBuf(2) + rcvBuf(3) * &H100 <> i - 8) Or _
                (2 <> i - 8) Or _
                (rcvBuf(8) + rcvBuf(9) * &H100 <> 0) Then
                Exit Function
            End If

            rcvParam = rcvBuf(4) + rcvBuf(5) * &H100UL + rcvBuf(6) * &H10000UL + rcvBuf(7) * &H1000000UL

            Send8266Cmd = 1
        Catch ex As TimeoutException
        End Try
    End Function

    Private Sub espFlash(binBuf As Byte(), adrs As ULong, binSize As ULong, progressStart As Long, progressEnd As Long)
        Const BLOCK_SIZE = 1024
        Dim i As Long
        Dim j As Long
        Dim rcvParam As ULong
        Dim data() As Byte
        Dim ret As Long

        ' ESP_FLASH_BEGIN(02)		size		0x200		0x400		offset
        'C0 00 02 10 00	00000000	binSize 	00000200	00000400	adrs	C0

        ReDim data(&H10 - 1)
        setUlong(data, 0, binSize)
        setUlong(data, 4, &H200)
        setUlong(data, 8, &H400)
        setUlong(data, 12, adrs)
        ret = Send8266Cmd(&H2, 0, data, rcvParam)
        If ret <> 1 Then Throw New Exception("erase error")

        progressWlan.Value = progressStart

        ' ESP_FLASH_DATA(03)		len			seq			0			0
        'C0 00 03 10 04	000000EF	00000400	00000000	00000000	00000000	FF .. C0
        ReDim data(&H10 + BLOCK_SIZE - 1)
        For i = 0 To binSize - 1 Step BLOCK_SIZE

            setUlong(data, 0, BLOCK_SIZE)
            setUlong(data, 4, i \ BLOCK_SIZE)
            setUlong(data, 8, 0)
            setUlong(data, 12, 0)

            Dim sum As ULong
            sum = &HEF
            For j = 0 To BLOCK_SIZE - 1
                sum = sum Xor binBuf(i + j)
                data(16 + j) = binBuf(i + j)
            Next
            ret = Send8266Cmd(&H3, sum, data, rcvParam)
            If ret <> 1 Then Throw New Exception("write error")

            progressWlan.Value = progressStart + (progressEnd - progressStart) * i / binSize
        Next
    End Sub

    Private Sub buttonBurnWlan_Click(sender As Button, e As EventArgs) Handles buttonBurnWlan.Click

        buttonBurnFW.Enabled = False
        buttonBurnWlan.Enabled = False
        buttonBurnPicWlan.Enabled = False
        progressWlan.Value = 0
        Const BLOCK_SIZE = 1024
        Const ADRS_START = &H1000
        Const PARAM1_START = &HFC000
        Const PARAM3_START = &HFE000
        Const PARAM2_START = &H3FE000    ' for 32Mbit
        Const PARAM_SIZE = &H1000

        labelStatus.Text = "最新Download中"
        Application.DoEvents()
        Try
            Dim wc As Net.WebClient = New Net.WebClient()
            wc.DownloadFile("http://sohta02.web.fc2.com/release/bitClock.WlanFW.latest.bin", appPath & "\latest_wlan.bin")
        Catch ex As Exception
        End Try
        labelStatus.Text = ""

        Try
            SerialPort1Open()

            OpenFileDialog1.InitialDirectory = appPath
            OpenFileDialog1.FileName = "latest_wlan.bin"
            OpenFileDialog1.Filter = "WLANソフト|*.bin"
            If sender.Name <> "buttonBurnPicWlan" Then
                If OpenFileDialog1.ShowDialog() <> DialogResult.OK Then GoTo Exit_
            End If

            Dim i As Long
            Dim fs As New FileStream(OpenFileDialog1.FileName, FileMode.Open, FileAccess.Read)

            Dim binSize As Long = (fs.Length + (BLOCK_SIZE - 1)) And (Not (BLOCK_SIZE - 1))
            Dim binBuf(binSize - 1) As Byte
            For i = 0 To binSize - 1
                binBuf(i) = &HFF
            Next
            fs.Read(binBuf, 0, binSize)
            fs.Close()

            If (binSize > &HFB000) Then
                MsgBox("ファイルサイズダメ")
                Exit Try
            End If

            Dim portName As String = SerialPort1.PortName

            SerialPort1.WriteLine("")
            SerialPort1.WriteLine("U2")
            Threading.Thread.Sleep(1000) : progressWlan.Value = 5
            Threading.Thread.Sleep(1000) : progressWlan.Value = 10
            SerialPort1.DiscardInBuffer()

            Dim rcvParam As ULong
            Dim data() As Byte
            Dim ret As Long

            ' ESP_SYNC(08)
            'C0 00 08 24 00	00000000	20120707	55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 55 C0
            'C0 01 08 02 00	20120707	0000 C0
            SerialPort1.ReadTimeout = 1 * 1000
            ReDim data(&H24 - 1)
            setUlong(data, 0, &H20120707)
            For i = 4 To &H24 - 1
                data(i) = &H55
            Next
            For i = 0 To 3 - 1
                ret = Send8266Cmd(&H8, 0, data, rcvParam)
                If (ret = 1) And (rcvParam = &H20120707) Then Exit For
                Threading.Thread.Sleep(1000)
                SerialPort1.DiscardInBuffer()
            Next

            Threading.Thread.Sleep(500)
            SerialPort1.DiscardInBuffer()
            SerialPort1.ReadTimeout = 5 * 1000

            ' ESP_FLASH_BEGIN(02)		size		0x200		0x400		offset 
            'C0 00 02 10 00	00000000	00000000	00000200	00000400	00000000	C0

            ReDim data(&H10 - 1)
            setUlong(data, 0, &H0)
            setUlong(data, 4, &H200)
            setUlong(data, 8, &H400)
            setUlong(data, 12, &H0)
            ret = Send8266Cmd(&H2, 0, data, rcvParam)
            If ret <> 1 Then Throw New Exception("erase error")

            ' ESP_WRITE_REG(09)		60000240(ESP_DATA_ADDR)	00000000
            ' ESP_WRITE_REG(09)		60000200(ESP_CMD_ADDR)	10000000(ESP_CMD_RDID)
            ' ESP_READ_REG(0A)		60000240(ESP_DATA_ADDR) 091540EF
            'C0 00 09 10 00	00000000	60000240	00000000	00000000	00000000	C0
            'C0 00 09 10 00	00000000	60000200	10000000	10000000	00000000	C0
            'C0 00 0A 04 00	00000000	60000240	C0
            'C0 01 0A 02 00	091540EF	0000 C0

            ReDim data(&H10 - 1)
            setUlong(data, 0, &H60000240)
            setUlong(data, 4, &H0)
            setUlong(data, 8, &H0)
            setUlong(data, 12, &H0)
            ret = Send8266Cmd(&H9, 0, data, rcvParam)
            If ret <> 1 Then Throw New Exception("write reg error")

            ReDim data(&H10 - 1)
            setUlong(data, 0, &H60000200)
            setUlong(data, 4, &H10000000)
            setUlong(data, 8, &H10000000)
            setUlong(data, 12, &H0)
            ret = Send8266Cmd(&H9, 0, data, rcvParam)
            If ret <> 1 Then Throw New Exception("write reg error")

            ReDim data(&H4 - 1)
            setUlong(data, 0, &H60000240)
            ret = Send8266Cmd(&HA, 0, data, rcvParam)
            If ret <> 1 Then Throw New Exception("read reg error")
            Dim FlashType As ULong
            FlashType = (rcvParam And &HFF00) + (rcvParam And &HFF0000) \ &H10000UL
            If FlashType <> &H4016 Then labelFlashType.Text = Hex(FlashType)

            espFlash(binBuf, ADRS_START, binSize, 15, 100)

            If checkInit.Checked = True Then
                For i = 0 To PARAM_SIZE - 1
                    binBuf(i) = &HFF
                Next
                espFlash(binBuf, PARAM1_START, PARAM_SIZE, 100, 100)
                espFlash(binBuf, PARAM2_START, PARAM_SIZE, 100, 100)
                espFlash(binBuf, PARAM3_START, PARAM_SIZE, 100, 100)
            End If

            progressWlan.Value = 100
            data(0) = &HDE
            data(1) = &HAA
            data(2) = &HDE
            data(3) = &HAA
            SerialPort1.Write(data, 0, 4)
            Threading.Thread.Sleep(100)

            SerialPort1Close()

            labelStatus.Text = "成功しました"
        Catch ex As Exception
            MsgBox(ex.Message)
            labelStatus.Text = "失敗しました"
        End Try
Exit_:
        SerialPort1Close()
        buttonBurnFW.Enabled = True
        buttonBurnWlan.Enabled = True
        buttonBurnPicWlan.Enabled = True
    End Sub

    Private Sub buttonBurnPicWlan_Click(sender As Button, e As EventArgs) Handles buttonBurnPicWlan.Click
        Call buttonBurnFW_Click(sender, e)
        If labelStatus.Text <> "成功しました" Then Exit Sub

        buttonBurnFW.Enabled = False
        buttonBurnWlan.Enabled = False
        buttonBurnPicWlan.Enabled = False
        labelStatus.Text = "WLAN更新中..."
        Threading.Thread.Sleep(5000)
        Call buttonBurnWlan_Click(sender, e)
    End Sub

    Private Sub textUrl_KeyDown(sender As Object, e As KeyEventArgs) Handles textParam1.KeyDown
        If e.KeyCode = Keys.Enter Then
            buttonHttp_Click(sender, e)
        End If
    End Sub
End Class

